Lattice Grid Buy a licence

demo D309

A network drawn as your network in Angular

A glyph per device where you put it, every circuit its own line coloured by the rule on the column, and a click that ties a line back to its row

nodes: [{ id, label, icon, x, y }]

The office network drawn the way a network team draws it: a glyph per device in the place you put it, and one line per circuit coloured by how much headroom it has left. Click a line to find its row, or a device to find everything plugged into it.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<lattice-grid [config]="gridConfig" style="display:block;height:300px"></lattice-grid>' +
    '<div id="chart" style="height:420px;margin-top:12px"></div>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  gridConfig = {
    rowKey: 'id',
    selection: 'multiple',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 130 } },
      { field: 'from', title: 'From', filter: { type: 'set' } },
      { field: 'to', title: 'To', filter: { type: 'set' } },
      { field: 'utilisation', title: 'Utilisation', type: 'number', format: { decimals: 0, suffix: '%' }, filter: { type: 'number' } },
    ],
    rows: [/* circuit links: id, circuit, from, to, utilisation */],
  };

  ngAfterViewInit() {
    createChart({
      grid: this.gridRef.grid, container: '#chart', type: 'network',
      source: 'from', target: 'to', y: { col: 'utilisation', fn: 'sum' }, selection: true,
      title: 'The office network, circuit by circuit',
      nodes: [
        { id: 'edge-router', label: 'Edge router', x: 0.5, y: 0.08 },
        { id: 'firewall', label: 'Firewall', x: 0.5, y: 0.33 },
        { id: 'switch-a', label: 'Switch A', x: 0.26, y: 0.58 },
        { id: 'switch-b', label: 'Switch B', x: 0.74, y: 0.58 },
        { id: 'app-servers', label: 'App servers', x: 0.16, y: 0.9 },
        { id: 'database', label: 'Database', x: 0.5, y: 0.9 },
        { id: 'file-store', label: 'File store', x: 0.84, y: 0.9 },
      ],
    });
  }
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid })],
});

Devices where you put them, drawn as what they are

A generic graph settles wherever the maths takes it and draws every device as the same circle, which is how a network you know well arrives as a diagram you cannot read.

Name the devices instead. Each one takes a glyph from the icon set the grid already holds, so a router looks like a router and a server looks like a server, and each one takes a position given as a fraction of the plot, so the edge router sits at the top, the switches sit under it and the racks sit under those. Pinning one device never reshuffles the rest. A device you name that appears in no circuit is still drawn, because a box with nothing plugged into it is worth seeing.

Every circuit stays its own reading

Two circuits between the same pair used to be added together, which produced a number nothing measures: a pair of links at seventy per cent is not one link at a hundred and forty.

Here they are drawn side by side, in row order, each with its own value, its own colour and its own tooltip, and the pointer picks out the line you are actually over. The colours come from the utilisation rules on the column, so the cell in the table and the line on the diagram can never disagree, and the legend names the rules that fired. Select a line and the table jumps to that circuit; select a device and every circuit it terminates lights up while the rest dim.

How do I draw my own devices on a network chart?

Give the chart nodes: [{ id, label, icon, x, y }]. The id matches the value in your source and target columns, icon is any name in the grid’s icon set (a built-in, or one you registered), and x and y are fractions of the plot that pin the device there. Colour comes from the conditional-formatting rules on the value column, so there is nothing to configure twice; linkWidth fixes the stroke width where you do not want it to follow the value, and selection: true wires clicks on lines and devices to the rows behind them.

Lattice Grid Buy a licence

demo D309

A network drawn as your network in React

A glyph per device where you put it, every circuit its own line coloured by the rule on the column, and a click that ties a line back to its row

nodes: [{ id, label, icon, x, y }]

The office network drawn the way a network team draws it: a glyph per device in the place you put it, and one line per circuit coloured by how much headroom it has left. Click a line to find its row, or a device to find everything plugged into it.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import { createLatticeReact } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/charts.esm.min.js';

  const { LatticeGrid, LatticeChart } = createLatticeReact({ React, createGrid, createChart });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 130 } },
    { field: 'from', title: 'From', filter: { type: 'set' } },
    { field: 'to', title: 'To', filter: { type: 'set' } },
    { field: 'utilisation', title: 'Utilisation', type: 'number', format: { decimals: 0, suffix: '%' }, filter: { type: 'number' } },
  ];
  const rows = [/* circuit links: id, circuit, from, to, utilisation */];
  const nodes = [
    { id: 'edge-router', label: 'Edge router', x: 0.5, y: 0.08 },
    { id: 'firewall', label: 'Firewall', x: 0.5, y: 0.33 },
    { id: 'switch-a', label: 'Switch A', x: 0.26, y: 0.58 },
    { id: 'switch-b', label: 'Switch B', x: 0.74, y: 0.58 },
    { id: 'app-servers', label: 'App servers', x: 0.16, y: 0.9 },
    { id: 'database', label: 'Database', x: 0.5, y: 0.9 },
    { id: 'file-store', label: 'File store', x: 0.84, y: 0.9 },
  ];

  function App() {
    const [grid, setGrid] = React.useState(null);

    return (
      <>
        <LatticeGrid rowKey="id" selection="multiple" columns={columns} rows={rows} onGridReady={setGrid} style={{ height: '300px' }} />
        {/* A glyph per device and one line per circuit: two circuits between
            a pair stay two readings. */}
        {grid && (
          <LatticeChart grid={grid} type="network" source="from" target="to" y={{ col: 'utilisation', fn: 'sum' }} selection nodes={nodes} title="The office network, circuit by circuit" style={{ height: '420px', marginTop: '12px' }} />
        )}
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Devices where you put them, drawn as what they are

A generic graph settles wherever the maths takes it and draws every device as the same circle, which is how a network you know well arrives as a diagram you cannot read.

Name the devices instead. Each one takes a glyph from the icon set the grid already holds, so a router looks like a router and a server looks like a server, and each one takes a position given as a fraction of the plot, so the edge router sits at the top, the switches sit under it and the racks sit under those. Pinning one device never reshuffles the rest. A device you name that appears in no circuit is still drawn, because a box with nothing plugged into it is worth seeing.

Every circuit stays its own reading

Two circuits between the same pair used to be added together, which produced a number nothing measures: a pair of links at seventy per cent is not one link at a hundred and forty.

Here they are drawn side by side, in row order, each with its own value, its own colour and its own tooltip, and the pointer picks out the line you are actually over. The colours come from the utilisation rules on the column, so the cell in the table and the line on the diagram can never disagree, and the legend names the rules that fired. Select a line and the table jumps to that circuit; select a device and every circuit it terminates lights up while the rest dim.

How do I draw my own devices on a network chart?

Give the chart nodes: [{ id, label, icon, x, y }]. The id matches the value in your source and target columns, icon is any name in the grid’s icon set (a built-in, or one you registered), and x and y are fractions of the plot that pin the device there. Colour comes from the conditional-formatting rules on the value column, so there is nothing to configure twice; linkWidth fixes the stroke width where you do not want it to follow the value, and selection: true wires clicks on lines and devices to the rows behind them.